#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

void * print_function (void * ptr) {

  int i; 
  for (i=1;i<1000000000;i++);

  fprintf (stdout, "%s\n", (char *) ptr);

  pthread_exit(NULL);
}

int main () {
  pthread_t thread1, thread2;
  char message1[] = "I am thread 1";
  char message2[] = "I am thread 2";
  int iret1, iret2;

  pthread_attr_t attr;

  pthread_attr_init(&attr);
  pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);

  iret1 = pthread_create (&thread1, &attr, print_function, (void *) message1);
  iret2 = pthread_create (&thread2, &attr, print_function, (void *) message2);

  pthread_attr_destroy(&attr);

  fprintf (stdout, "Before\n");
  fflush (stdout);

  pthread_join (thread1, NULL);
  pthread_join (thread2, NULL); 

  fprintf (stdout, "After\n");
  fflush (stdout);
     
  exit(0);
}
